Informa errores

Para emitir un error desde una función de Cloud Functions en Stackdriver Error Reporting, realiza lo siguiente:

Node.js

// These WILL be reported to Stackdriver Error Reporting
    console.error(new Error('I failed you'));
    console.error('I failed you', new Error('I failed you too'));
    throw new Error('I failed you'); // Will cause a cold start if not caught

    // These will NOT be reported to Stackdriver Error Reporting
    console.info(new Error('I failed you')); // Logging an Error object at the info level
    console.error('I failed you'); // Logging something other than an Error object
    throw 1; // Throwing something other than an Error object
    callback('I failed you');
    res.status(500).send('I failed you');

Python

# This WILL be reported to Stackdriver Error
    # Reporting, and WILL NOT show up in logs or
    # terminate the function.
    from google.cloud import error_reporting
    client = error_reporting.Client()

    try:
        raise RuntimeError('I failed you')
    except RuntimeError:
        client.report_exception()

    # This WILL be reported to Stackdriver Error Reporting,
    # and WILL terminate the function
    raise RuntimeError('I failed you')

    # WILL NOT be reported to Stackdriver Error Reporting, but will show up
    # in logs
    import logging
    print(RuntimeError('I failed you (print to stdout)'))
    logging.warn(RuntimeError('I failed you (logging.warn)'))
    logging.error(RuntimeError('I failed you (logging.error)'))
    sys.stderr.write('I failed you (sys.stderr.write)\n')

    # This WILL be reported to Stackdriver Error Reporting
    from flask import abort
    return abort(500)

Go


    package tips

    import (
    	"fmt"
    	"net/http"
    	"os"
    )

    // HTTPError describes how errors are handled in an HTTP function.
    func HTTPError(w http.ResponseWriter, r *http.Request) {
    	// An error response code is NOT reported to Error Reporting.
    	// http.Error(w, "An error occurred", http.StatusInternalServerError)

    	// Printing to stdout and stderr is NOT reported to Error Reporting.
    	fmt.Println("An error occurred (stdout)")
    	fmt.Fprintln(os.Stderr, "An error occurred (stderr)")

    	// Calling log.Fatal sets a non-zero exit code and is NOT reported to Error
    	// Reporting.
    	// log.Fatal("An error occurred (log.Fatal)")

    	// Panics are reported to Error Reporting.
    	panic("An error occurred (panic)")
    }
    

Si deseas obtener un informe de errores más detallado, puedes usar las bibliotecas cliente de Stackdriver Error Reporting.

En Cloud Console, puedes ver los errores informados en Stackdriver Error Reporting. También puedes ver los errores informados desde una función en particular cuando la seleccionas en la lista de funciones de Cloud Console.

Las excepciones sin detectar que genera la función aparecerán en Stackdriver Error Reporting. Ten en cuenta que algunas excepciones sin detectar, por ejemplo, las que se muestran de forma asíncrona, pueden causar un inicio en frío en una invocación de función futura. Esta situación reduce el rendimiento de la función.